clear all;
close all;
clc;
fid = fopen('input.txt');
C = textscan( fid, '%f %f %f');
M = cell2mat(C);
fclose(fid);
points = 16; 
K = (M(1,2)-M(1,1))*16;
for i = 2:1:17
    initials(i-1,:) = M(i,:);
end
initials(:,4) = ones([16 1]);
initialPos=[M(9,:)' M(10,:)' M(11,:)' M(12,:)'];
initialPos(4,:)= [1 1 1 1];
k = 1;
j=1;
tetas = zeros(K/16,23);
e3 = [0 0 1];
e2 = [0 1 0];
%rot = [1 0 0; 0 cos(0) sin(0); 0 -sin(0) cos(0)]*[cos(5*pi/180) 0 -sin(5*pi/180); 0 1 0; sin(5*pi/180) 0 cos(5*pi/180)]*	[cos(-30*pi/180) sin(-30*pi/180) 0; -sin(-30*pi/180) cos(-30*pi/180) 0; 0 0 1];
rot = [1 0 0;0 1 0;0 0 1];
for i=2:16:K
    
    center = (M(i+8,:) + M(i+9,:))/2;
    currentPos = [(M(i+8,:)-center)' (M(i+9,:)-center)' (M(i+10,:)-center)' (M(i+11,:)-center)'];
    currentPos(4,:) = [1 1 1 1]; 
    %calculating transformation matrix
    T = currentPos*inv(initialPos);
    rot2 = T(1:3,1:3);
    eulerAngles(1,1) = atan2(-rot2(2,3),rot2(3,3));
    eulerAngles(1,2) = asin(rot2(1,3));
    eulerAngles(1,3) = atan2(-rot2(1,2),rot2(1,1)); 
%     %unit vectors e2 e3
    v19 = rot'*(M(i+8,:)-(M(i+10,:)+M(i+11,:))/2)';
    v19 = [0 v19(2,1) v19(3,1)]';
    v20 = rot'*(M(i+10,:)-M(i+11,:))';
%     e3= (v19/norm(v19))';
%     e2 = -(v20/norm(v20))';
%     
    %angle for neck 1
    p1 = (rot'*(M(i+1,:)-(M(i+2,:)+M(i+5,:))/2)');
    v1 = [0 p1(2,1) p1(3,1)]/(sqrt(p1(2,1)^2+p1(3,1)^2));
    teta1 = -acos(e3*v1')*sign(p1(2,1));
    %angle for neck 2
    v2 = [p1(1,1) 0 sqrt(p1(2,1)^2+p1(3,1)^2)]/(sqrt(p1(1,1)^2+p1(2,1)^2+p1(3,1)^2));
    teta2 = acos(e3*v2')*sign(p1(1,1));
    %angle for left shoulder 1
    p2 = (rot'*(M(i+3,:)-M(i+2,:))');
    %sqrt(p2(1,1)^2+p2(2,1)^2+p2(3,1)^2)
    v3 = [0 p2(2,1) p2(3,1)]/(sqrt(p2(2,1)^2+p2(3,1)^2));
    teta3 = - acos(e2*v3')*sign(p2(3,1));
    %angle for right shoulder 1
    p3 = (rot'*(M(i+6,:)-M(i+5,:))');
    v4 = [0 p3(2,1) p3(3,1)]/(sqrt(p3(2,1)^2+p3(3,1)^2));
    teta4 = - acos(e2*v4')*sign(p3(3,1));
    %angle for left shoulder 2
    v5 = [p2(1,1) sqrt(p2(2,1)^2+p2(3,1)^2) 0]/(sqrt(p2(1,1)^2+p2(2,1)^2+p2(3,1)^2));
    teta5 = - acos(e2*v5')*sign(p2(1,1));
    %angle for right shoulder 2
    v6 = [p3(1,1) sqrt(p3(2,1)^2+p3(3,1)^2) 0]/(sqrt(p3(1,1)^2+p3(2,1)^2+p3(3,1)^2));
    teta6 = acos(e2*v6')*sign(p3(1,1));
    %angle for left shoulder 3
    v7 = (rot'*(M(i+2,:)-M(i+3,:))');
    v7 = v7/norm(v7);
    v8 = (rot'*(M(i+4,:)-M(i+3,:))');
    v8 = v8/norm(v8);
    teta7 =  acos(([1 0 0; 0 cos(teta3) sin(teta3); 0 -sin(teta3) cos(teta3)]*[cos(teta5) 0 -sin(teta5); 0 1 0; sin(teta5) 0 cos(teta5)]*e3')'*cross(v8,v7))*sign(v7'*cross(v8,cross(v8,v7)))+pi/2;
    %angle for right shoulder 3
    v9 = (rot'*(M(i+5,:)-M(i+6,:))');
    v10 = (rot'*(M(i+7,:)-M(i+6,:))');
    v9 = v9/norm(v9);
    v10 = v10/norm(v10);   
    teta8 = - acos(([1 0 0; 0 cos(teta4) sin(teta4); 0 -sin(teta4) cos(teta4)]*[cos(teta6) 0 -sin(teta6); 0 1 0; sin(teta6) 0 cos(teta6)]*e3')'*cross(v9,v10))*sign(cross(v10,cross(v9,v10))'*v9)+pi/2;
    %angle for left elbow
    teta9 = pi - acos(v7'*v8);
    %angle for right elbow
    teta10 = -pi+ acos(v9'*v10);
    %angle for left hip 1
    p4 = (rot'*(M(i+12,:)-M(i+10,:))')';
    v11 = [0 p4(1,2) p4(1,3)]';
    v11 = v11/norm(v11);
    teta11 = acos(-e3*v11)*sign(p4(1,2));
    %angle for right hip 1
    p5 = (rot'*(M(i+13,:)-M(i+11,:))')';
    v12 = [0 p5(1,2) p5(1,3)]';
    v12 = v12/norm(v12);
    teta12 = acos(-e3*v12)*sign(p5(1,2));
    %angle for left hip 2
    v13 = (1/sqrt(p4(1,1)^2 + p4(1,2)^2 + p4(1,3)^2))*[p4(1,1) 0 sqrt(p4(1,2)^2 + p4(1,3)^2)]';
    teta13 = -acos(e3*v13)*sign(p4(1,1));
    %angle for right hip 2
    v14 = (1/sqrt(p5(1,1)^2 + p5(1,2)^2 + p5(1,3)^2))*[p5(1,1) 0 sqrt(p5(1,2)^2 + p5(1,3)^2)]';
    teta14 = -acos(e3*v14)*sign(p5(1,1));
    %angle for left knee
    v15 = rot'*(M(i+14,:)-M(i+12,:))';
    v15 = v15/norm(v15);
    v16 = rot'*(M(i+10,:)-M(i+12,:))';
    v16 = v16/norm(v16);
    teta15 =  pi - acos(v15'*v16);
    %angle for right knee
    v17 = rot'*(M(i+15,:)-M(i+13,:))';
    v17 = v17/norm(v17);
    v18 = rot'*(M(i+11,:)-M(i+13,:))';
    v18 = v18/norm(v18);
    teta16 = pi - acos(v17'*v18);
    %angle for waist
  
    v19 = v19/norm(v19);
    v20 = v20/norm(v20);
    teta17 = acos(v20'*v19)+pi/12;
    % angle between legs...
    teta18 = acos(v11'*v12);
    
    %tetas(j,:) = [k center(1,1) center(1,2) center(1,3) 0 0 0 teta1 teta2 teta4 teta6 0 teta10 teta3 teta5 0 teta9 teta14 teta12 teta16 M(i+11,:) M(i+13,:) M(i+15,:) teta13 teta11 teta15 M(i+10,:) M(i+12,:) M(i+14,:)];
    tetas(j,:) = [k center(1,1) center(1,2) center(1,3)  teta17 0 eulerAngles(1,3)/4 teta1 teta2 teta4 teta6 teta8 teta10 teta3 teta5 teta7 teta9 teta13 teta11 teta15 teta12 teta14 teta16];
    j = j+1;
    k = k+1;
end

% fid = fopen('angles1.txt', 'wt');
% fprintf(fid, '%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f\n', tetas);
% fclose(fid)        
% 
%         